VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmCopiarComAPIBarraProgresso 
   BorderStyle     =   1  'Fixed Single
   Caption         =   ">> Copiar Com API - Exibe Barra de Progresso <<"
   ClientHeight    =   3255
   ClientLeft      =   1695
   ClientTop       =   1515
   ClientWidth     =   6090
   Icon            =   "frmCopiarComAPIBarraProgresso.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3255
   ScaleWidth      =   6090
   StartUpPosition =   1  'CenterOwner
   Begin MSComDlg.CommonDialog dlgProcura 
      Left            =   4800
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Frame Frame 
      Height          =   2895
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4575
      Begin MSComctlLib.ProgressBar prgCopiaArquivos 
         Height          =   375
         Left            =   240
         TabIndex        =   10
         Top             =   1920
         Width           =   4095
         _ExtentX        =   7223
         _ExtentY        =   661
         _Version        =   393216
         Appearance      =   1
      End
      Begin VB.CommandButton cmdProcuraDestino 
         Caption         =   "P&rocura..."
         Enabled         =   0   'False
         Height          =   375
         Left            =   3480
         TabIndex        =   6
         Top             =   1080
         Width           =   975
      End
      Begin VB.TextBox txtCaminhoDestino 
         Enabled         =   0   'False
         Height          =   285
         Left            =   120
         TabIndex        =   5
         Top             =   1080
         Width           =   3255
      End
      Begin VB.CommandButton cmdProcuraOrigem 
         Caption         =   "&Procura..."
         Height          =   375
         Left            =   3480
         TabIndex        =   3
         Top             =   480
         Width           =   975
      End
      Begin VB.TextBox txtCaminhoOrigem 
         Height          =   285
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   3255
      End
      Begin VB.CommandButton cmdEncerrar 
         Caption         =   "&Encerrar"
         Height          =   375
         Left            =   3480
         TabIndex        =   9
         Top             =   2400
         Width           =   975
      End
      Begin VB.CommandButton cmdCopiar 
         Caption         =   "Copiar &Arquivo"
         Height          =   375
         Left            =   2160
         TabIndex        =   8
         Top             =   2400
         Width           =   1335
      End
      Begin VB.Label Destinationlabel 
         Caption         =   "&Destino:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   840
         Width           =   855
      End
      Begin VB.Label Filelabel 
         Caption         =   "&Origem:"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   1335
      End
      Begin VB.Label Percentlabel 
         Caption         =   "Percentual completado :"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   1545
         Width           =   3135
      End
   End
End
Attribute VB_Name = "frmCopiarComAPIBarraProgresso"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Function CopiarArquivo(Origem As String, Destino As String) As Single
    'Vriaveis
    Static Buf As String
    Dim BTest As Long
    Dim FSize As Long
    Dim Chunk As Integer
    Dim F1 As Integer
    Dim F2 As Integer
    
    Const BUFSIZE = 1024       'define o tamanho do buffer
    
    If Len(Dir(Destino)) Then      'verifica se o arquivo de destino ja existe
       Resposta = MsgBox(Destino + Chr(10) + Chr(10) + "Arquivo j existe. Deseja sobrescrever o arquivo existente ?", vbYesNo + vbQuestion) 'exibe ao usurio uma caixa de mensagem
       If Resposta = vbNo Then 'Se clicou no boto No
          Exit Function        'sai da rotina
       Else                    'senao
          Kill Destino             'exclui o arquivo existente e continua a executar o codigo
       End If
    End If
     
    On Error GoTo FileCopyError  'se houver erro trata aqui
    F1 = FreeFile                'retorna o numero do arquivo disponivel
    Open Origem For Binary As F1    'abre o arquivo de destino
    F2 = FreeFile                'retorna o numero do arquivo disponivel
    Open Destino For Binary As F2    'abre o arquivo de destino
     
    FSize = LOF(F1)
    BTest = FSize - LOF(F2)
    
    Do
    If BTest < BUFSIZE Then
       Chunk = BTest
    Else
       Chunk = BUFSIZE
    End If
          
    Buf = String(Chunk, " ")
    Get F1, , Buf
    Put F2, , Buf
    BTest = FSize - LOF(F2)
    
    prgCopiaArquivos.Value = (100 - Int(100 * BTest / FSize)) 'avanca com a barra de progresso durante a copia
    
    Loop Until BTest = 0
    Close F1 'fecha o fonte
    Close F2 'fecha o destino
    CopiarArquivo = FSize
    
    MsgBox "Arquivo copiado com sucesso.", vbInformation, "Copia com sucesso"
    
    prgCopiaArquivos.Value = 0 'retorna a barra de progresso para o valor zero
    
    Exit Function      'sai da rotina
    
FileCopyError:         'trata o erro aqui
    MsgBox "Erro durante a copia...!, Tente novamente..." 'exibe mensagem de erro
    
    Close F1           'fecha a fonte
    Close F2           'fecha o destino
End Function

Public Function ExtraiNome(SpecIn As String) As String
   
    Dim i As Integer
    Dim saida As String
       
    On Error Resume Next 'ignora qualquer erro
       
    For i = Len(SpecIn) To 1 Step -1
        If Mid(SpecIn, i, 1) = "\" Then
           saida = Mid(SpecIn, i + 1) 'extrai o nome do arquivo do caminho
           Exit For
        End If
    Next i

    ExtraiNome = saida 'retorna o nome do arquivo extraido
End Function

Private Sub cmdCopiar_Click()
    On Error Resume Next 'ignora quaisquer erros
    
    If txtCaminhoOrigem.Text = "" Then 'tenha certeza de que a origem foi informado
       MsgBox "Voc deve definir o nome e o caminho do arquivo de origem.", vbCritical 'se no informar exibe mensagem
       Exit Sub                                                                        'sai da rotina
    End If
    
    If txtCaminhoDestino.Text = "" Then 'tenha certeza de que o arquivo de destino foi informado
       MsgBox "Voc deve definir o nome e caminho do arquivo de destino.", vbCritical 'se nao informar exibe mensagem
       Exit Sub                                                                       'sai da rotina
    End If
    
    'se tudo estiver correto ento copia o arquivo
    prgCopiaArquivos.Value = CopiarArquivo(txtCaminhoOrigem.Text, txtCaminhoDestino.Text)
End Sub

Private Sub cmdEncerrar_Click()
    Unload Me 'sai do programa
End Sub

Private Sub cmdProcuraDestino_Click()
    Dim bi As BROWSEINFO 'declara as variaveis
    Dim rtn&
    Dim pidl&
    Dim path As String
    Dim pos As Integer
    
    bi.hOwner = Me.hWnd                 'centraliza o dialogo na tela
    bi.lpszTitle = "Procura destino..." 'define o titulo do texto
    bi.ulFlags = BIF_RETURNONLYFSDIRS   'o tipo de pasta para retornar
    pidl& = SHBrowseForFolder(bi)       'exibe o dialogo
      
    path = Space(512)               'define o tamanho maximo
    T = SHGetPathFromIDList(ByVal pidl&, ByVal path) 'obtem o caminho selecionado
    
    pos% = InStr(path$, Chr$(0))    'extrai o caminho da string
    SpecIn = Left(path$, pos - 1)   'define o caminho extraido
    
    If Right$(SpecIn, 1) = "\" Then 'esteja certo de que a barra "\" esta no fim do caminho
       saida = SpecIn               'se nao estiver , nao faa nada
    Else                            'senao
       saida = SpecIn + "\"         'inclui a barra  "\" no fim do caminho
    End If
    
    txtCaminhoDestino.Text = saida + ExtraiNome(txtCaminhoOrigem.Text) 'monta o nome dos arquivos
End Sub
    
Private Sub txtCaminhoOrigem_Change()
    txtCaminhoDestino.Enabled = True 'habilita a caixa de texto
    cmdProcuraDestino.Enabled = True 'habilita o boto Procurar
    txtCaminhoDestino.SetFocus       'poe o cursor na caixa de texto destino
End Sub

Private Sub cmdProcuraOrigem_Click()
    dlgProcura.DialogTitle = "Procura origem..." 'define o titulo
    dlgProcura.ShowOpen                          'exibe o dialogo
    txtCaminhoOrigem.Text = dlgProcura.FileName    'define o texto da caixa de origem
End Sub
